Feature: dry-running the detach command

  Background:
    Given a Git repo with origin
    And the branches
      | NAME     | TYPE    | PARENT | LOCATIONS     |
      | branch-1 | feature | main   | local, origin |
    And the commits
      | BRANCH   | LOCATION      | MESSAGE   |
      | branch-1 | local, origin | commit 1a |
      | branch-1 | local, origin | commit 1b |
    And the branches
      | NAME     | TYPE    | PARENT   | LOCATIONS     |
      | branch-2 | feature | branch-1 | local, origin |
    And the commits
      | BRANCH   | LOCATION      | MESSAGE   |
      | branch-2 | local, origin | commit 2a |
      | branch-2 | local, origin | commit 2b |
    And the branches
      | NAME     | TYPE    | PARENT   | LOCATIONS     |
      | branch-3 | feature | branch-2 | local, origin |
    And the commits
      | BRANCH   | LOCATION      | MESSAGE   |
      | branch-3 | local, origin | commit 3a |
      | branch-3 | local, origin | commit 3b |
    And the branches
      | NAME     | TYPE    | PARENT   | LOCATIONS     |
      | branch-4 | feature | branch-3 | local, origin |
    And the commits
      | BRANCH   | LOCATION      | MESSAGE   |
      | branch-4 | local, origin | commit 4a |
      | branch-4 | local, origin | commit 4b |
    And the current branch is "branch-2"
    When I run "git-town detach --dry-run"

  Scenario: result
    Then Git Town runs the commands
      | BRANCH   | COMMAND                                              |
      | branch-2 | git fetch --prune --tags                             |
      |          | git rebase --onto main branch-1 --no-update-refs     |
      |          | git checkout branch-3                                |
      | branch-3 | git pull                                             |
      |          | git rebase --onto branch-1 branch-2 --no-update-refs |
      |          | git push --force-with-lease                          |
      |          | git checkout branch-4                                |
      | branch-4 | git pull                                             |
      |          | git rebase --onto branch-3 branch-2 --no-update-refs |
      |          | git push --force-with-lease                          |
      |          | git checkout branch-2                                |
    And the initial commits exist now
    And the initial lineage exists now
    And the initial lineage exists now

  Scenario: undo
    When I run "git-town undo"
    Then Git Town runs no commands
    And the initial commits exist now
    And the initial lineage exists now
