Feature: cannot ship a branch with uncommitted changes

  Background:
    Given a Git repo with origin
    And the branches
      | NAME    | TYPE    | PARENT | LOCATIONS     |
      | feature | feature | main   | local, origin |
    And the commits
      | BRANCH  | LOCATION      | MESSAGE        |
      | feature | local, origin | feature commit |
    And the current branch is "feature"
    And Git setting "git-town.ship-strategy" is "api"
    And the origin is "git@github.com:git-town/git-town.git"
    And an uncommitted file
    When I run "git-town ship -m done"

  Scenario: result
    Then Git Town runs no commands
      | BRANCH  | COMMAND                            |
      | feature | git fetch --prune --tags           |
      | (none)  | Looking for proposal online ... ok |
    And Git Town prints the error:
      """
      you have uncommitted changes. Did you mean to commit them before shipping?
      """
    And the uncommitted file still exists

  Scenario: undo
    When I run "git-town undo"
    Then Git Town runs no commands
    And the initial branches and lineage exist now
    And the initial commits exist now
    And the uncommitted file still exists
